/*
 * MainFrame.java
 *
 * Created on December 12, 2005, 1:00 PM
 *
 *     Global Javadoc Viewer
 *
 *     Copyright(C) 2005,2006 Zeev (Vladimir) Belkin. All rights reserved.
 *
   <h1>The Artistic License</h1>

<tt>



<p>Preamble</p>

<p>The intent of this document is to state the conditions under which a
Package may be copied, such that the Copyright Holder maintains some
semblance of artistic control over the development of the package,
while giving the users of the package the right to use and distribute
the Package in a more-or-less customary fashion, plus the right to make
reasonable modifications.</p>

<p>Definitions:</p>

<ul>

<li>	"Package" refers to the collection of files distributed by the
	Copyright Holder, and derivatives of that collection of files
	created through textual modification.</li>

<li>	"Standard Version" refers to such a Package if it has not been
	modified, or has been modified in accordance with the wishes
	of the Copyright Holder.</li>

<li>	"Copyright Holder" is whoever is named in the copyright or
	copyrights for the package.</li>

<li>	"You" is you, if you're thinking about copying or distributing
	this Package.</li>

<li>	"Reasonable copying fee" is whatever you can justify on the
	basis of media cost, duplication charges, time of people involved,
	and so on.  (You will not be required to justify it to the
	Copyright Holder, but only to the computing community at large
	as a market that must bear the fee.)</li>

<li>	"Freely Available" means that no fee is charged for the item
	itself, though there may be fees involved in handling the item.
	It also means that recipients of the item may redistribute it
	under the same conditions they received it.</li>
	
</ul>

<p>1. You may make and give away verbatim copies of the source form of the
Standard Version of this Package without restriction, provided that you
duplicate all of the original copyright notices and associated disclaimers.</p>

<p>2. You may apply bug fixes, portability fixes and other modifications
derived from the Public Domain or from the Copyright Holder.  A Package
modified in such a way shall still be considered the Standard Version.</p>

<p>3. You may otherwise modify your copy of this Package in any way, provided
that you insert a prominent notice in each changed file stating how and
when you changed that file, and provided that you do at least ONE of the
following:</p>

<blockquote>

    <p>a) place your modifications in the Public Domain or otherwise make them
    Freely Available, such as by posting said modifications to Usenet or
    an equivalent medium, or placing the modifications on a major archive
    site such as ftp.uu.net, or by allowing the Copyright Holder to include
    your modifications in the Standard Version of the Package.</p>

    <p>b) use the modified Package only within your corporation or organization.</p>

    <p>c) rename any non-standard executables so the names do not conflict
    with standard executables, which must also be provided, and provide
    a separate manual page for each non-standard executable that clearly
    documents how it differs from the Standard Version.</p>

    <p>d) make other distribution arrangements with the Copyright Holder.</p>
	
</blockquote>

<p>4. You may distribute the programs of this Package in object code or
executable form, provided that you do at least ONE of the following:</p>

<blockquote>

    <p>a) distribute a Standard Version of the executables and library files,
    together with instructions (in the manual page or equivalent) on where
    to get the Standard Version.</p>

    <p>b) accompany the distribution with the machine-readable source of
    the Package with your modifications.</p>

    <p>c) accompany any non-standard executables with their corresponding
    Standard Version executables, giving the non-standard executables
    non-standard names, and clearly documenting the differences in manual
    pages (or equivalent), together with instructions on where to get
    the Standard Version.</p>

    <p>d) make other distribution arrangements with the Copyright Holder.</p>

</blockquote>

<p>5. You may charge a reasonable copying fee for any distribution of this
Package.  You may charge any fee you choose for support of this Package.
You may not charge a fee for this Package itself.  However,
you may distribute this Package in aggregate with other (possibly
commercial) programs as part of a larger (possibly commercial) software
distribution provided that you do not advertise this Package as a
product of your own.</p>

<p>6. The scripts and library files supplied as input to or produced as
output from the programs of this Package do not automatically fall
under the copyright of this Package, but belong to whomever generated
them, and may be sold commercially, and may be aggregated with this
Package.</p>


<p>7. The name of the Copyright Holder may not be used to endorse or promote
products derived from this software without specific prior written permission.</p>

<p>8. THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.</p>

<p>The End</p>
 
 */

package globaldocs;

import javax.swing.text.html.*;
import java.awt.Dimension;
import java.awt.Component;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.image.BufferedImage;
import javax.swing.tree.*;
import javax.swing.*;
import javax.swing.text.html.HTMLEditorKit.ParserCallback;
import javax.swing.text.html.HTMLEditorKit.Parser;
import java.util.*;
import java.util.regex.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.text.*;
import javax.swing.event.*; 
import javax.xml.parsers.DocumentBuilderFactory;        
import javax.xml.parsers.DocumentBuilder;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import java.awt.datatransfer.*;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Graphics;
import java.awt.RenderingHints;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
/**
 *
 * @author  Zeev Belkin
 */
public class MainFrame extends javax.swing.JFrame {
  static interface Home {
      public URL getHome();
      public URL jPackageHome();
      public boolean hasHome();
  };
  static class A implements Comparable<A>, Home {
	String fullName,version,urlBase;
        
        URL homeUrl=null;
        
        int jPackageId=-1;
        
        public URL jPackageHome() {
          if (jPackageId>=0) try {
            return new URL("http://jpackage.org/rpm.php?id="+jPackageId);
          } catch (Throwable t) {}
          return null;
        }


        
        public synchronized URL getHome() {
          if (homeUrl==null&&jPackageId>=0) try {
            InputStream is=openStream(jPackageHome(),URL_STREAM_TIMEOUT);
            if (is!=null) try {
              final InputStreamReader isr=new InputStreamReader(is);
              parser.parse(
                isr,
                new ParserCallback() {
                   boolean urlPrefixFound=false;
                   
         	   public void handleStartTag(HTML.Tag t, MutableAttributeSet a, int pos) {
		     if (urlPrefixFound&&t==HTML.Tag.A) try {
  		        String href=(String)a.getAttribute(HTML.Attribute.HREF);
                        homeUrl=new URL(href);
                        urlPrefixFound=false;
                        isr.close(); // abort the parsing
		      } catch (Throwable tr) {
                      }
	           }
                   
                   public void handleText(char[] data, int pos) {
                     if (data!=null&&data.length>0) {
                       urlPrefixFound=new String(data).trim().equalsIgnoreCase("url:");
                     }
	           }
                }
                ,
                true
              );
            } finally {
              is.close();
            }
          } catch (Throwable t) {} 
          return homeUrl;
        } 
        
        public boolean hasHome() {
          return homeUrl!=null||jPackageId>-1;
        }
        
	
        public static A add(String fn,String v,String urlBase) {
          return add(fn,v,urlBase,null);
        }
        
	public static A add(String fn,String v,String urlBase,String home) {
	   A lastAssemble=new A();
           lastAssemble.urlBase=urlBase;
	   lastAssemble.fullName=fn; lastAssemble.version=v;
           try {
             lastAssemble.homeUrl=new URL(home);
           } catch(Throwable t) {}
	   assembles.add(lastAssemble);
	   return lastAssemble;
	}
	
	public int compareTo(A o) {
	    int i=fullName.compareTo(o.fullName);
	    if (i==0) i=version.compareTo(o.version);
	    return i;
	}
	
	class C implements Comparable<C>, Home {
            
            public URL jPackageHome() {
              return A.this.jPackageHome();
            }
            
            public URL getHome() {
              return A.this.getHome();
            }
            
            public boolean hasHome() {
              return A.this.hasHome();
            }

            
            private boolean _isInterface=false;
            
            boolean isInterface() {
                return _isInterface;
            }
            
            protected void setInterface(boolean b) {
                _isInterface=b;
            }
            
	    public A envelope() {
		return A.this;
	    }
	    
	    String fullName,url;
	    public int compareTo(C o) {
		int i=fullName.compareTo(o.fullName);
		if (i==0) i=A.this.compareTo(o.envelope());
		return i;
	    }

	    public URL getUrl() {
              try {
                return 
                  new URL(urlBase+'/'+url);
              } catch (Throwable t) {}
              return null;
	    }
            
            public URL getPackageUrl() throws MalformedURLException {
               String t=getUrl().toString();
               int i=t.lastIndexOf('/');
               return (i>=0)
                 ?new URL( t.substring(0, i+1)+"package-summary.html")
                 :null;
            }           

	};
	
	public C addClass(String u,boolean isInterface) {
          if (u.endsWith(".java.html")) return null;
	  C c=new C();
          c.setInterface(isInterface);
	  c.url=u;
	  c.fullName=u.substring(0,u.lastIndexOf('.')).replace('/','.');
	  classes.add(c);
	  return c;
	}

        public String getVersionedName() {
           return fullName+'-'+version;
        }
        
        
        class TheParserCallback extends ParserCallback{
                boolean italic=false;

    	        String href=null,title=null,target=null;               
                
                
          	public void handleEndTag(HTML.Tag t, int pos) {
                  if (t==HTML.Tag.A) {
                     if ("classFrame".equals(target)) {
                        //System.out.println(href+" "+title+" "+target);
                        boolean isInterface=italic||title.startsWith("interface ");
		        addClass(href,isInterface);
		     }
                      
                  } 
	        }          
                
         	public void handleStartTag(HTML.Tag t, MutableAttributeSet a, int pos) {
                  if (t==HTML.Tag.I) {
                     italic=true; 
                  } else
		  if (t==HTML.Tag.A) {
                     italic=false; 
                     
		     href=(String)a.getAttribute(HTML.Attribute.HREF);
		     title=(String)a.getAttribute(HTML.Attribute.TITLE);
		     target=(String)a.getAttribute(HTML.Attribute.TARGET);
		  }
	        }
	    };

            
         public void parseClassList(Reader r) {
             try {
                parser.parse(r,new TheParserCallback(),true);
             } catch (Throwable t) {
             }
         } 
         
         public void parseClassList(URL u) {
             try {
                splashScreen.add("opening of "+u.toString());
                InputStream is=openStream(u,URL_STREAM_TIMEOUT);
                if (is!=null) {
                  splashScreen.add("parsing of "+u.toString());  
                  parseClassList(new InputStreamReader(is));
                  is.close();
                } else {
                  splashScreen.add("the opening is failed ("+u.toString()+")");
                }
             } catch (Throwable t) {
             }
         }
     
         public void parseClassList() {
             try {
                 parseClassList(new URL(urlBase+"allclasses-frame.html"));
             } catch (Throwable t) {
             }
         }
  }
  
  
  static Parser parser=new javax.swing.text.html.parser.ParserDelegator(); //null;
  
  static TreeSet<A.C> classes=new TreeSet<A.C>();
  static TreeSet<A> assembles=new TreeSet<A>();
  
  //static A lastAssemble=null;
  
  static Vector<File> findAllClasses(File f) {
      Vector<File> rv=new Vector<File>();
      File a=new File(f,"allclasses-frame.html");
      if (a.exists()) {
        rv.add(a);
      } else
        for (File d:f.listFiles()) if (d.isDirectory()&&!d.getName().startsWith(".")) {
          rv.addAll(findAllClasses(d));
        }
      return rv;
  }
  
  public static InputStream openStream(final URL u,long millis) throws java.io.IOException {
    final InputStream rv[]={null};
    Thread t=new Thread() {
      public void run() {
        try {  
          rv[0]=u.openStream();
        } catch (Throwable t) {}  
      }
    };
    t.start();
    try {
      t.join(millis);
    } catch (Throwable tr) {
    }
    return rv[0];
  }
  
  static final int URL_STREAM_TIMEOUT=4000;
  static final String JPACKAGE_URL_PREFIX="rpm.php?id=";
  
  void handleJPackages() {
    try {
      InputStream is=openStream(new URL("http://jpackage.org/"),URL_STREAM_TIMEOUT);
      if (is!=null) try {
        InputStreamReader isr=new InputStreamReader(is); 

       	ParserCallback pc=new ParserCallback() {
                boolean prevTagFits=false;
                int id;
                
                public void handleText(char[] data, int pos) {
                  if (prevTagFits&&data.length>0) {
                      
                     String s=new String(data);
                     if (s.endsWith("jpp")) {
                       int i=s.lastIndexOf('-');
                       if (i>0) s=s.substring(0, i);
                     }
                     
                     int i=s.lastIndexOf('-');
                     if (i>0&&s.substring(i+1).matches("(\\d|\\.)*\\d"))
                        s=s.substring(0,i);
                     //System.out.println("&&&&&&&&&&&");
                     
                     //System.out.println(id+" "+s);
                     
                     for (A a:assembles) if (a.fullName.equals(s)) {
                       a.jPackageId=id;
   //                    System.out.println(id+" "+s);
                       break;
                     }
                     
                     prevTagFits=false;
                  } 
	        }
                
         	public void handleStartTag(HTML.Tag t, MutableAttributeSet a, int pos) {
                  
                  prevTagFits=false;
                  if (t==HTML.Tag.A) {
		     String href=(String)a.getAttribute(HTML.Attribute.HREF);
                     if (href!=null&&href.startsWith(JPACKAGE_URL_PREFIX)) try {
                        id=Integer.parseInt(href.substring(JPACKAGE_URL_PREFIX.length()));
                        prevTagFits=true;
                     } catch (Throwable exception) {}
		  }
	        }
	    };
                        
         parser.parse(isr,pc,true);     

      } finally {
        is.close();
      }
    } catch (Throwable t) {
      System.err.println(t);
    }
  }
  
          
  File user_home=new File(System.getProperty("user.home"));
  
  File configDirectory() {
    File confdir=new File(user_home,".globaldocs");
    if (!confdir.exists()) confdir.mkdirs();
    return confdir;
  }
  
  File configDirectory=configDirectory(),
       configFile=new File(configDirectory,"config.xml");
  
  public void saveConfig(org.w3c.dom.Document configuration) {
     try { 
        TransformerFactory tFactory = TransformerFactory.newInstance();
        Transformer transformer = tFactory.newTransformer();
            
        DOMSource source = new DOMSource(configuration);
        
        
        FileOutputStream fos=new FileOutputStream( configFile);
        try {
          StreamResult result=new StreamResult(fos);
          transformer.transform(source, result);
        } finally {
          fos.close();
        }  
     } catch (Throwable t) {}
  }

   org.w3c.dom.Document configuration=loadConfiguration();
   
   org.w3c.dom.Document loadConfiguration() {
      boolean cfe=configFile.exists();
      org.w3c.dom.Document doc=
          cfe
         ?loadConfiguration(configFile)
         :loadConfiguration(getResourceUrl("globaldocs/res/config.xml"))
       ;
      if (!cfe) saveConfig(doc);
      return doc; 
   }

   org.w3c.dom.Document loadConfiguration(File  src) {
     org.w3c.dom.Document doc=null;
     try {
        DocumentBuilder builder=DocumentBuilderFactory.newInstance().newDocumentBuilder();
        InputStream is=new FileInputStream(src);
        if (is!=null) try {
          doc=builder.parse(is);
        } finally {
          is.close();
        }
     } catch (Throwable t) {}
     return doc;
  }
 
  
  org.w3c.dom.Document loadConfiguration(URL src) {
     org.w3c.dom.Document doc=null;
     try {
        DocumentBuilder builder=DocumentBuilderFactory.newInstance().newDocumentBuilder();
        InputStream is=openStream(src,URL_STREAM_TIMEOUT);
        if (is!=null) try {
          doc=builder.parse(is);
        } finally {
          is.close();
        }
     } catch (Throwable t) {}
     return doc;
  }
  
  void buildGblTree() {
      try {
          
          String v=null;
                    
          File usrShareJavadoc=new File("/usr/share/javadoc");
          if (usrShareJavadoc.exists()) for (File f:usrShareJavadoc.listFiles())
              if (f.isDirectory()&&f.getCanonicalPath().length()!=f.getAbsolutePath().length())  {
              Vector<File> allPathes=findAllClasses(f);
              if (allPathes.size()==0) continue;
              v=f.getCanonicalPath().substring(f.getAbsolutePath().length());
              if (!Character.isDigit(v.charAt(0))) v=v.substring(1);
                /*
                System.out.println(f.getName()+
                   ' '+v
                );
                 */
              for (File aPath:allPathes)
                 A.add(f.getName(),v, "file:"+aPath.getParent()+'/').parseClassList();              
          }
          
          if (!classes.isEmpty()) handleJPackages();
          
          
          if (configuration!=null) {
            org.w3c.dom.NodeList docsets=configuration.getElementsByTagName("docset");
            if (docsets!=null) for (int di=0;di<docsets.getLength();di++) {
              org.w3c.dom.Node docset=docsets.item(di);
              org.w3c.dom.NamedNodeMap attrs=docset.getAttributes();
              org.w3c.dom.Node 
                 project=attrs.getNamedItem("project"),
                 base=attrs.getNamedItem("base"),
                 ver=attrs.getNamedItem("ver"),
                 home=attrs.getNamedItem("home")
                 ;
              if (project!=null&&base!=null&&ver!=null&&home!=null) try {
                A.add(
                  project.getNodeValue(),
                  ver.getNodeValue(),
                  base.getNodeValue(),
                  home.getNodeValue()
                ).parseClassList();
              } catch(Throwable x) {
                System.err.println(x);
              }
            }
          }
          System.gc();
          
          for (A.C cl:classes) {
              
              //             if (cl.fullName.startsWith("javax.xml.datatype"))
              //               System.out.println(cl.fullName);
              
              
              
              
              TheMutableTreeNode nodeFor=
                      rootNode.getNodeFor(cl.fullName);
              
              Object payload=nodeFor.getUserObject();
              
              if (payload!=null) {
                  if (payload instanceof A.C && nodeFor.findNamedChild(ASSEMBLES)==null) {
                      A.C theClass=(A.C)payload;
                      TheMutableTreeNode
                              n=new TheMutableTreeNode(DOCSET),
                              a=new TheMutableTreeNode(theClass.envelope().getVersionedName());
                      nodeFor.add(n);
                      n.setUserObject(ASSEMBLES);
                    //?  nodeFor.setUserObject("");
                      a.setUserObject(theClass);
                      n.add(a);
                      a=new TheMutableTreeNode(cl.envelope().getVersionedName());
                      a.setUserObject(cl);
                      n.add(a);
                  } else {
                      TheMutableTreeNode n=nodeFor.findNamedChild(ASSEMBLES);
                      if (n!=null) {
                          TheMutableTreeNode
                                  a=new TheMutableTreeNode(cl.envelope().getVersionedName());
                          a.setUserObject(cl);
                          n.add(a);
                      }
                  }
              } else {
                  nodeFor.setUserObject(cl);
              }
              // Packages
              
              TreeNode tn=nodeFor.getParent();
              if (tn instanceof PackageTreeNode) {
                  PackageTreeNode
                          pack=(PackageTreeNode)tn;
                  
                  String asname=cl.envelope().getVersionedName();
                  URL purl=cl.getPackageUrl(),oldpurl=pack.getUrl();
                  
                  TheMutableTreeNode n=pack.findNamedChild(ASSEMBLES);
                  if (n!=null) {
                      PackageTreeNode
                              p=(PackageTreeNode)n.findNamedChild(cl.envelope());
                      if (p==null) {
                          p=new PackageTreeNode(asname);
                          p.setUrl(purl);
                          p.setUserObject(cl.envelope());
                          n.add(p);
                      }
                  } else if (oldpurl==null) {
                      pack.setUrl(purl);
                      pack.setUserObject(cl.envelope());
                  } else if (!purl.equals(oldpurl)) {
                     //? pack.setUrl(null);
                      TheMutableTreeNode asnode=new TheMutableTreeNode(DOCSET);
                      A asm=(A)pack.getUserObject();
                      asnode.setUserObject(ASSEMBLES);
                      pack.insert(asnode,0);
                      
                      PackageTreeNode
                              p1=new PackageTreeNode(asm.getVersionedName()),
                              p2=new PackageTreeNode(asname);
                      
                      p1.setUrl(oldpurl);
                      p1.setUserObject(asm);
                      p2.setUrl(purl);
                      p2.setUserObject(cl.envelope());
                      
                      asnode.add(p1);
                      asnode.add(p2);
                      
                      //? pack.setUserObject(null);
                      
                  }
              }
              
              
              
              //        System.out.println(cl.getUrl());
          }
          
          // we don't need these tables more
          for (A.C cls:classes) cls.fullName=null;
          classes=null;
          assembles=null;
          System.gc();
          
      } catch (Throwable t) {
          System.err.println(t);
      }
  }
  
//=========================================================
  
  HTMLEditorKit editorKit=new HTMLEditorKit();
 
  static class ClassTreeNode extends TheMutableTreeNode {
      public ClassTreeNode(String _name) { super(_name); }
      
      
      private boolean _isInterface=false;
      
      public boolean isInterface() {
          return _isInterface;
      }
      
      
      public void setUserObject(Object uo) {
          if (uo!=null&&uo instanceof A.C) {
             _isInterface=((A.C)uo).isInterface(); 
          }
          super.setUserObject(uo);
      }
  }
  
  static class PkTreeNode extends TheMutableTreeNode {
      public PkTreeNode(String _name) { super(_name); }
  }
  
  static class PackageTreeNode extends PkTreeNode {
      
      public PackageTreeNode(String _name) { super(_name); }
      
      /**
       * Holds value of property url.
       */
      private URL url=null;
      
      /**
       * Getter for property url.
       * @return Value of property url.
       */
      public URL getUrl() {
          
          return this.url;
      }
      
      /**
       * Setter for property url.
       * @param url New value of property url.
       */
      public void setUrl(URL url) {
          
          if (this.url!=null)
              if (url2node.containsKey(this.url))
                  url2node.remove(this.url);
          
          
          this.url = url;
          
          if (url!=null)
              url2node.put(url,this);
          
      }     
      
      public String toString() {
          Object uo=getUserObject();
          if (uo!=null && uo instanceof A) {
              A a=(A)uo;
              if (ASSEMBLES.equals(getParentUserObject())||(findNamedChild(ASSEMBLES)!=null))
                  return super.toString();
              return super.toString()+" ("+a.getVersionedName()+")";
          }
          return super.toString();
      }
     

      public String getVersionedName() {
          Object uo=getUserObject();
          if (uo!=null && uo instanceof A) {
              A a=(A)uo;
              return a.getVersionedName();
          }
          return "";
      }
      
  };
  
  static class TheMutableTreeNode 
    extends DefaultMutableTreeNode
    implements Home
  {
      
      public void setUserObject(Object userObject) {
          Object oldUO=getUserObject();
          
          if (oldUO!=null&&oldUO instanceof A.C &&!oldUO.equals(userObject)) {
              A.C c=(A.C)oldUO;
              URL oldUrl=c.getUrl();
              if (url2node.containsKey(oldUrl))
                  url2node.remove(oldUrl);
          }
          
          super.setUserObject(userObject);
          if ((userObject!=null)&&userObject instanceof A.C) {
              url2node.put(getUrl(),this);
          }
      }
      
      TheMutableTreeNode getPParent() {
          if (getParent()!=null) {
              TreeNode tn=getParent().getParent();
              if (tn!=null&& tn instanceof TheMutableTreeNode)
                  return (TheMutableTreeNode)tn;
          }
          return null;
      }
      
      Object getParentUserObject() {
          if (getParent()!=null) {
              DefaultMutableTreeNode tn=(DefaultMutableTreeNode)getParent();
              return tn.getUserObject();
          }
          return null;
      }
      
      String getTitle() {
          if (ASSEMBLES.equals(getParentUserObject()))
              return getPParent().getClassPath()+" ("+toString()+")";
          return getClassPath();
      }
      
      String getClassPath() {
          String r=name;
          TreeNode n=this;
          while (((n=n.getParent())!=null)&&(n!=rootNode)) {
              TheMutableTreeNode m=(TheMutableTreeNode)n;
              r=m.name+'.'+r;
          }
          return r;
      }
      
      
      TheMutableTreeNode findNamedChild(Object key) {
          Enumeration<TheMutableTreeNode> en=children();
          while (en.hasMoreElements())  {
              TheMutableTreeNode n=en.nextElement();
              if (key.equals(n.getUserObject())) return n;
          }
          return null;
      }
      
      
      private String name=null;
      
      private TheMutableTreeNode allocatePath(String path) {
          return allocatePath(rootNode,path);
      }
      
      private TheMutableTreeNode allocatePath(DefaultMutableTreeNode p,String path) {
          TheMutableTreeNode r=null;
          
          int i=path.indexOf('.');
          
          if (i<0)
              p.add((r=new ClassTreeNode(path)));
          else {
              String tail=path.substring(i+1);
              if (tail.indexOf('.')>=0)
                  r=new PkTreeNode(path.substring(0, i));
              else
                  r=new PackageTreeNode(path.substring(0, i));
              p.add(r);
              r=allocatePath(r, tail);
          }
          
          return r;
      }
      
      TheMutableTreeNode getNodeFor(String path) {
          //       System.out.println(">"+path);
          
          
          TheMutableTreeNode r=findBestChoise(path);
          if (r==null) return allocatePath(path);
          
          String cp=r.getClassPath();
          
//        System.out.println(cp);
          
          int rpl=cp.length();
          if (rpl==path.length())
              return r;
          return allocatePath(r,path.substring(rpl+1));
      }
      
      protected TheMutableTreeNode findBestChoise(String path) {
          int i=path.indexOf('.');
          if (i<0) {
              return path.equals(name)?this:null;
          }
          String head=path.substring(0, i),tail=path.substring(i+1);
          if (head.equals(name)) {
              TheMutableTreeNode theBest=null;
              if (children!=null) for (Object obj:children) if (obj instanceof TheMutableTreeNode) {
                  TheMutableTreeNode
                          n=(TheMutableTreeNode)obj,
                          b=n.findBestChoise(tail);
                  if (b!=null)
                      if ((theBest==null)||(theBest.getDepth()<b.getDepth()))
                          theBest=b;
              }
              return (theBest==null)?this:theBest;
          }
          if (this==rootNode) {
              if (children!=null) for (Object obj:children) if (obj instanceof TheMutableTreeNode) {
                  TheMutableTreeNode
                          n=((TheMutableTreeNode)obj).findBestChoise(path);
                  if (n!=null) return n;
              }
          }
          return null;
      }
      
 
      
      public String getVersionedName() {
          Object uo=getUserObject();
          if (uo!=null && uo instanceof A.C) {
              A.C c=(A.C)uo;
              return c.envelope().getVersionedName();
          }
          return "";
      }
     
      
      public String toString() {
          return name==null?"":name;
      }
      
      public TheMutableTreeNode() {}
      
      public TheMutableTreeNode(String _name) { name=_name; }
      
      public URL getUrl() {
          Object payload=getUserObject();
          if (payload!=null && payload instanceof A.C) try {
              return ((A.C)payload).getUrl();
          } catch (Throwable t) {}
          return null;
      }
      
      
      public boolean hasHome() {
        Object payload=getUserObject();
        if (payload!=null&&payload instanceof Home) 
           return ((Home)payload).hasHome();
        return false;
      } 
      
      public URL getHome() {
        Object payload=getUserObject();
        if (payload!=null&&payload instanceof Home) 
           return ((Home)payload).getHome();
        return null;
      }      
      
      public URL jPackageHome() {
        Object payload=getUserObject();
        if (payload!=null&&payload instanceof Home) 
           return ((Home)payload).jPackageHome();
        return null;
      }
      
  };
  
  static TheMutableTreeNode rootNode=new TheMutableTreeNode();
  
  /*
  interface Visitor<E> {
    public boolean visit(E element);
  };
  
  boolean walk(Element el,Visitor<Element> vi) {
    if (el.getElementCount()==0)
       return vi.visit(el);
    
    for (int i=0;i<el.getElementCount();i++) 
      if (!vi.visit(el.getElement(i))) return false;
    
    return true;
  }*/
  
  int lastSearchEnd=0;
  String needle="";
  
  void findThenMove(String needle) {
      Document doc=jHtmlEditorPane.getDocument();
      Position
         start=doc.getStartPosition(),
           end=doc.getEndPosition();
      
      int so=start.getOffset(),eo=end.getOffset();
      
      if (eo>so) try {
        String  txt=doc.getText(so,eo-so).toUpperCase();
        int ix=txt.indexOf(needle.toUpperCase());
        
        if (ix>=0) {
          // jHtmlEditorPane.select(ix,ix+needle.length());
           jHtmlEditorPane.setCaretPosition(ix);
        }
        
      } catch (Throwable t) {
      }      
  }
  
  void execFindAgain() {
      if (needle.length()==0) execFindDialog();
      else {
          jHtmlEditorPane.grabFocus();
          Document doc=jHtmlEditorPane.getDocument();
          Position
                  start=doc.getStartPosition(),
                  end=doc.getEndPosition();
          
          int so=start.getOffset(),eo=end.getOffset();
          
          if (eo>so) try {
              String  txt=doc.getText(so,eo-so).toUpperCase(),
                      N=needle.toUpperCase();
              int ix=txt.indexOf(N, lastSearchEnd);
              
              if (ix>=0) {
                  jHtmlEditorPane.select(ix,lastSearchEnd=ix+needle.length());
              } else {
                  lastSearchEnd=0;
                  ix=txt.indexOf(N);
                  if (ix>=0) jHtmlEditorPane.select(ix,lastSearchEnd=ix+needle.length());
              }
              
          } catch (Throwable t) {
          }
      }
  }
  
  
  void execFindDialog() {
      //String
      JOptionPane op=
              new JOptionPane("Find What:",JOptionPane.PLAIN_MESSAGE,JOptionPane.OK_CANCEL_OPTION);
      
      op.setWantsInput(true);
      op.setInitialSelectionValue(needle);
      
      JDialog dlg=op.createDialog(this, "Find");
      
      dlg.setModal(true);
      dlg.setVisible(true);


      
      Integer val=(Integer)op.getValue();
      if (val==null||val!=JOptionPane.OK_OPTION) return;
      
      String n=(String)op.getInputValue();
      
      if (n==null) return;
      
      
      n=n.trim();
      if (n.length()>0) {
          needle=n;
          
          Document doc=jHtmlEditorPane.getDocument();
          Position
                  start=doc.getStartPosition(),
                  end=doc.getEndPosition();
          
          int so=start.getOffset(),eo=end.getOffset();
          
          if (eo>so) try {
              jHtmlEditorPane.grabFocus();

              
              String  txt=doc.getText(so,eo-so).toUpperCase(),
                      N=needle.toUpperCase();
              int ix=txt.indexOf(N, lastSearchEnd);
              
              if (ix>=0) {
                  jHtmlEditorPane.select(ix,lastSearchEnd=ix+needle.length());
              } else {
                  lastSearchEnd=0;
                  ix=txt.indexOf(N);
                  if (ix>=0) jHtmlEditorPane.select(ix,lastSearchEnd=ix+needle.length());
              }
              
          } catch (Throwable t) {
          }
      }
  }
  
  URL getResourceUrl(String path) {
      return getClass().getClassLoader().getResource(path);
  }
  
  ImageIcon loadIcon(String path) {
      return new ImageIcon(getResourceUrl(path));
  }
  
  Icon icClass=loadIcon("globaldocs/res/class.gif");
  Icon icInterface=loadIcon("globaldocs/res/interface.gif");
  ImageIcon icRa=loadIcon("globaldocs/res/helpviewer_forward.png");
  Icon icRightArrow=scaleIcon(icRa,icRa.getIconWidth(),12);
  ImageIcon icNul=loadIcon("globaldocs/res/unvisible_arrow.png");
  Icon icNull=scaleIcon(icNul,icNul.getIconWidth(),12);
  
  ImageIcon icPackage_closed=loadIcon("globaldocs/res/p_closed.gif");
  ImageIcon icPackage_open=loadIcon("globaldocs/res/p_open.gif");
  ImageIcon icPackages_closed=loadIcon("globaldocs/res/pks_closed.gif");
  ImageIcon icPackages_open=loadIcon("globaldocs/res/pks_open.gif");
  ImageIcon icCup=loadIcon("globaldocs/res/cup.gif");
  
  
  static ImageIcon scaleIcon(ImageIcon ic,int w,int h) {
     BufferedImage img=new BufferedImage(
       w,h,BufferedImage.TYPE_4BYTE_ABGR
     );
     
     int hh=(ic.getIconHeight()-h)>>1,
         ww=(ic.getIconWidth()-w)>>1;
     
     Graphics g=img.getGraphics();
     g.drawImage(
       ic.getImage(), 
       0,0,ic.getIconWidth()-1-ww*2,ic.getIconHeight()-1-hh*2,
       0,0,ic.getIconWidth()-1,ic.getIconHeight()-1,
       null
     );
     g.dispose();
     return new ImageIcon(img);
  }
  
 
  
  static ImageIcon pressedIcon(ImageIcon ic) {
     BufferedImage img=new BufferedImage(
       ic.getIconWidth(),ic.getIconHeight(),BufferedImage.TYPE_4BYTE_ABGR
     );
     Graphics g=img.getGraphics();
     g.drawImage(ic.getImage(),2,2,ic.getIconWidth()-1,ic.getIconHeight()-1, 
                0,0,ic.getIconWidth()-1,ic.getIconHeight()-1,null);
     g.dispose();
     return new ImageIcon(img);
  }
  
  static void createPressedIcon(JButton b) {
    b.setPressedIcon(pressedIcon((ImageIcon)b.getIcon()));
  }
  
  static void createPressedIcon(JButton bs[]) {
    for (JButton b:bs) createPressedIcon(b);
  } 
  
  
  TreePath oldPath=null;
  
  JMenu miNavigate=null,miLink=null,miPage=null;
  
  static SplashScreen splashScreen=null;
  
  static void invokeAndWait(Runnable r) {
    try {
      SwingUtilities.invokeAndWait(r);
    } catch (Throwable t) {
      System.err.println(t);
    }
  }
  
  Dimension screenDimension=getToolkit().getScreenSize();
  
  class SplashScreen extends JFrame {
      private DefaultListModel model=new DefaultListModel();
      private JList list=new JList(model);
      private JScrollPane scrollingList = new JScrollPane(list);
      
      ImageIcon ic9kb8=loadIcon("globaldocs/res/9kb8.gif");

      private JLabel globe=new JLabel(ic9kb8);

      
      SplashScreen() {
        super(TITLE);
        setUndecorated(true);
        setIconImage(icCup.getImage());
      
        Dimension ssSize=new Dimension(400,240);
        setPreferredSize(ssSize);
                
        setSize(ssSize);
        setLocation((screenDimension.width-ssSize.width)>>1,(screenDimension.height-ssSize.height)>>1);
        JLabel lbl=new JLabel(TITLE,JLabel.CENTER);
      
        lbl.setForeground(Color.BLUE);
        lbl.setFont(new Font("Serif", Font.ITALIC|Font.BOLD,30));
        lbl.setBorder(new EmptyBorder(20,0,0,0));
       
        getRootPane().setBorder(new BevelBorder(BevelBorder.RAISED));
        
        getContentPane().add(lbl,BorderLayout.NORTH);
        
        
        globe.setBorder(new EmptyBorder(0,0,10,0));
        
        getContentPane().add(globe,BorderLayout.CENTER);
        getContentPane().add(scrollingList,BorderLayout.SOUTH);
        scrollingList.setPreferredSize(new Dimension(38, 80));
   //     list.setAutoscrolls(true);
        list.setFont(new Font("Sans Serif",Font.PLAIN, 10));
        
        getContentPane().setBackground(new Color(0xe0,0xf0,0xff));
          
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

        Dimension d=vs.getPreferredSize();
        d.width=12;
        vs.setPreferredSize(d);
        d=hs.getPreferredSize();
        d.height=12;
        hs.setPreferredSize(d);
        
  //      scrollingList.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        
        list.setBackground(new Color(0,0xff,0xff));
        list.setCellRenderer(
          new DefaultListCellRenderer() {
            public void setText(String s) {
              super.setText(s);
              setForeground(
                (s.indexOf("fail")>=0)
                  ?Color.RED
                  :Color.BLACK
              );
            }
          }
        );
                        
        pack();
        
        
      }
      
      public void thePorcessingEnd() {
        if (anyError)  {
            
           getContentPane().remove(scrollingList);
           getContentPane().remove(globe);
           getContentPane().add(scrollingList,BorderLayout.CENTER);
           JPanel pan=new JPanel();
           getContentPane().add(pan,BorderLayout.SOUTH);
           JLabel lbl=new JLabel("Processing of One or More Sources Has Been Failed");
           lbl.setForeground(Color.RED);
           lbl.setFont(new Font("Sans Serif",Font.PLAIN, 10));
           lbl.setHorizontalAlignment(JLabel.CENTER);
           pan.setLayout(new BorderLayout());
           pan.add(lbl,BorderLayout.NORTH);
           JButton btn=new JButton("Close");
           btn.setMnemonic(KeyEvent.VK_C);
           btn.addActionListener(
             new ActionListener() {
               public void actionPerformed(ActionEvent e) {
                 SplashScreen.this.dispose();      
               }
             }
           );
           
           pan.add(btn,BorderLayout.SOUTH);
           pack();
           setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
           setAlwaysOnTop(true);
        } else
          dispose(); 
      }
      
      JScrollBar vs=scrollingList.getVerticalScrollBar(),
                 hs=scrollingList.getHorizontalScrollBar();
      
      boolean anyError=false;
      
      public void add(final Object obj) {
        invokeAndWait(
          new Runnable() {
            public void run() {
                
              if (!anyError)
                anyError=obj.toString().indexOf("fail")>0;
              
              model.addElement(obj);
              vs.setValue(vs.getMaximum());
            }
          } 
        );
      }
  };
  
  /** Creates new form MainFrame */
  public MainFrame() {
      
      //Dimension sd=getToolkit().getScreenSize();
      vfyThatBrowsersExist();
      setIconImage(icCup.getImage());
      
      splashScreen=new SplashScreen(); 

      invokeAndWait(
         new Runnable() {
           public void run() {
             splashScreen.setVisible(true);
           } 
         }
      );

      
      buildGblTree();

      invokeAndWait(
         new Runnable() {
           public void run() {
             splashScreen.thePorcessingEnd();
           } 
         }
      );
      
      initComponents();
      
      createPressedIcon(
         new JButton[] {
          jButtonNext,jButtonPrev,jButtonUp,jButtonStop,jButtonHome,jButtonJPackage
         }
      );
      
      viewer_hs=jScrollBrowserPane.getHorizontalScrollBar();
      viewer_vs=jScrollBrowserPane.getVerticalScrollBar();
      
      setBounds(0,0,screenDimension.width,screenDimension.height);
      jScrollPane1.setPreferredSize(new Dimension(300,jScrollPane1.getPreferredSize().height));
      
      jTree.setCellRenderer(
              new DefaultTreeCellRenderer() {
          synchronized public Component getTreeCellRendererComponent(JTree tree, Object value,
                  boolean sel,
                  boolean expanded,
                  boolean leaf, int row,
                  boolean hasFocus) {
              
              Icon iclo=getClosedIcon(),iope=getOpenIcon(),icleaf=getLeafIcon();
              
              if (row==0) {
                  setClosedIcon(null);
                  setOpenIcon(null);
                  setLeafIcon(null);
              } else if (value instanceof ClassTreeNode) {
                  ClassTreeNode tn=(ClassTreeNode)value;
                  if (tn.isInterface()) {
                      setClosedIcon(icInterface);
                      setOpenIcon(icInterface);
                      setLeafIcon(icInterface);
                  } else {
                      setClosedIcon(icClass);
                      setOpenIcon(icClass);
                      setLeafIcon(icClass);
                  }
              } else if (value instanceof PackageTreeNode) {
                  setClosedIcon(icPackage_closed);
                  setOpenIcon(icPackage_open);
                  setLeafIcon(icCup);
              } else if (value instanceof PkTreeNode) {
                  setClosedIcon(icPackages_closed);
                  setOpenIcon(icPackages_open);
              } else {
                  setLeafIcon(icCup);
              }
              
              Component comp=super.getTreeCellRendererComponent(
                      tree,value, sel,expanded, leaf, row,  hasFocus);
              
              setClosedIcon(iclo);
              setOpenIcon(iope);
              setLeafIcon(icleaf);
              
              return comp;
          }
      }
      );
      
      buildMainMenu();     
      goAbout();
      
  }
  
  void buildMainMenu() {
      
      JMenuItem mi=jPopupMenu1.add("Copy");
      mi.setMnemonic(KeyEvent.VK_C);
      mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,KeyEvent.CTRL_MASK));
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              if (jHtmlEditorPane.getSelectedText()==null)
                  jHtmlEditorPane.selectAll();
              jHtmlEditorPane.copy();
          }
      }
      );
      
      mi=jPopupMenu1.add("Find");
      mi.setMnemonic(KeyEvent.VK_F);
      mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,KeyEvent.CTRL_MASK));
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              execFindDialog();
          }
      }
      );
      
      mi=jPopupMenu1.add("Find again");
      mi.setMnemonic(KeyEvent.VK_G);
      mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              execFindAgain();
          }
      }
      );
      
      
      
      miLink=new JMenu("Link");
      jPopupMenu1.add(miLink);
      miLink.setMnemonic(KeyEvent.VK_L);
      miLink.setVisible(false);
      
      miPage=new JMenu("Page");
      jPopupMenu1.add(miPage);
      miPage.setMnemonic(KeyEvent.VK_P);
              
      miNavigate=new JMenu("Navigate");
      jPopupMenu1.add(miNavigate);
      miNavigate.setMnemonic(KeyEvent.VK_N);

      
      
      mi=jPopupMenu1.add("Quit");
      mi.setMnemonic(KeyEvent.VK_Q);
      mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,KeyEvent.CTRL_MASK));
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              System.exit(1);
          }
      }
      );
      
      jPopupMenu1.addSeparator();
      
//      
      mi=jPopupMenu1.add("Help");
      mi.setMnemonic(KeyEvent.VK_H);
      mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             navigate(getResourceUrl("globaldocs/res/help.html"));
          }
      }
      );      
  
//      
      mi=jPopupMenu1.add("About");
      mi.setMnemonic(KeyEvent.VK_A);
      
      mi.addActionListener(
              new ActionListener() {
          public void actionPerformed(ActionEvent e) {
              goAbout();
          }
      }
      );
      
      InputMap am=jHtmlEditorPane.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);
      
      
      for (Component c:jPopupMenu1.getComponents())
          if (c instanceof JMenuItem ) {
          final JMenuItem mim=(JMenuItem)c;
          KeyStroke ac=mim.getAccelerator();
          if (ac!=null) {
              am.put(ac,
                      new AbstractAction() {
                        public void actionPerformed(ActionEvent e) {
                           mim.doClick();
                         }
                      }
              );
          }
       }

      jHtmlEditorPane.getKeymap().addActionForKeyStroke(
          KeyStroke.getKeyStroke(KeyEvent.VK_BACK_SPACE,0),
          new AbstractAction() {
              public void actionPerformed(ActionEvent e) {
                if (jButtonPrev.isEnabled())
                  jButtonPrev.doClick();
              }
          }
      );
      
      
  }
  
  void goAbout() {
      navigate(getResourceUrl("globaldocs/res/about.html"));
  }
  
  void changeUpButtonState() {
      TheMutableTreeNode tn=null;
      TreePath tp=jTree.getSelectionPath();
      if (tp!=null) {
          tn=(TheMutableTreeNode)tp.getLastPathComponent();
          if (tn!=null) {
              jButtonUp.setEnabled(tn.getLevel()>1);
              return;
          }
      }
      jButtonUp.setEnabled(false);
  }
  
  static String TITLE="Global Javadoc Viewer";
  static String TITLE_PREFIX="Global Javadoc View -- ";
  static String DOCSET="#project";
  static String ASSEMBLES="assembles";
  
  final static String externalBrowsers[][]={
     {"Konqueror","/usr/bin/konqueror"},
     {"Safari","/Applications/Safari.app/"},
     {"Firefox","/usr/bin/firefox"},
     {"Mozilla","/usr/bin/mozilla"},
     {"Opera","/usr/bin/opera"},
     {"Konqueror","/usr/local/bin/konqueror"},
     {"Firefox","/usr/local/bin/firefox"},
     {"Mozilla","/usr/local/bin/mozilla"},
     {"Opera","/usr/local/bin/opera"}
  };
  
  static Map<String,String> externalBrowser=new HashMap<String,String>();
 
  static void openUrlIn(String browser,String url) {
    String path=externalBrowser.get(browser);
    try {
      if (browser.equals("Safari"))
        Runtime.getRuntime().exec( new String[] { "open" , "-a", "Safari", url }) ;
      else
        Runtime.getRuntime().exec(
         new String[] {
          path,
          url
         }
       );
    } catch (Throwable t) {}  
  } 
 
  static void vfyThatBrowsersExist() {
     String os=System.getProperty("os.name").toLowerCase();
     boolean mswin=os.startsWith("windows"),
             macos=os.startsWith("mac os");
     
     for (String decl[]:externalBrowsers) 
       if (!externalBrowser.containsKey(decl[0])&&
           new File(decl[1]).exists()) externalBrowser.put(decl[0],decl[1]);
     
     if (mswin) 
       externalBrowser.put("Explorer","explorer");
  }
  
  static Hashtable<URL,TheMutableTreeNode> url2node=new
          Hashtable<URL,TheMutableTreeNode>();
  
  static URL withoutRef(URL url) {
     try {  
     return
       new URI(
                  url.getProtocol(),
                  url.getUserInfo(),
                  url.getHost(),
                  url.getPort(),
                  url.getPath(),
                  url.getQuery(),
                  null
        ).toURL();
     } catch (Throwable t) {}
     return null;
  }
  
  TheMutableTreeNode url2node(URL url) {
      TheMutableTreeNode r=url2node.get(url);
      if (r==null&&url!=null&&url.getRef()!=null)
          r=url2node.get(withoutRef(url));
      return r;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPopupMenu1 = new javax.swing.JPopupMenu();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree = new JTree(rootNode);
        jScrollBrowserPane = new javax.swing.JScrollPane();
        jHtmlEditorPane = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        jButtonPrev = new javax.swing.JButton();
        jButtonNext = new javax.swing.JButton();
        jButtonUp = new javax.swing.JButton();
        jButtonStop = new javax.swing.JButton();
        jButtonHome = new javax.swing.JButton();
        jButtonJPackage = new javax.swing.JButton();

        jPopupMenu1.setInvoker(jHtmlEditorPane);
        jPopupMenu1.setLabel("");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jSplitPane1.setDividerSize(6);
        jSplitPane1.setMinimumSize(new java.awt.Dimension(750, 550));
        jTree.setComponentPopupMenu(jPopupMenu1);
        jTree.setFocusable(false);
        jTree.setLargeModel(true);
        jTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTreeValueChanged(evt);
            }
        });
        jTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTreeMousePressed(evt);
            }
        });

        jScrollPane1.setViewportView(jTree);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jHtmlEditorPane.setComponentPopupMenu(jPopupMenu1);
        jHtmlEditorPane.setEditable(false);
        jHtmlEditorPane.setContentType("text/html");
        jHtmlEditorPane.setEditorKit(editorKit);
        jHtmlEditorPane.setMinimumSize(new java.awt.Dimension(100, 100));
        jHtmlEditorPane.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
            public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
                jHtmlEditorPaneHyperlinkUpdate(evt);
            }
        });
        jHtmlEditorPane.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jHtmlEditorPanePropertyChange(evt);
            }
        });

        jScrollBrowserPane.setViewportView(jHtmlEditorPane);

        jSplitPane1.setRightComponent(jScrollBrowserPane);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 1));

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        jPanel1.setMinimumSize(new java.awt.Dimension(10, 20));
        jPanel1.setPreferredSize(new java.awt.Dimension(10, 20));
        jButtonPrev.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/helpviewer_back.png")));
        jButtonPrev.setBorder(null);
        jButtonPrev.setBorderPainted(false);
        jButtonPrev.setContentAreaFilled(false);
        jButtonPrev.setEnabled(false);
        jButtonPrev.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonPrev.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPrevActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonPrev);

        jButtonNext.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/helpviewer_forward.png")));
        jButtonNext.setBorder(null);
        jButtonNext.setBorderPainted(false);
        jButtonNext.setContentAreaFilled(false);
        jButtonNext.setEnabled(false);
        jButtonNext.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNextActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonNext);

        jButtonUp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/up.png")));
        jButtonUp.setBorder(null);
        jButtonUp.setBorderPainted(false);
        jButtonUp.setContentAreaFilled(false);
        jButtonUp.setEnabled(false);
        jButtonUp.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUpActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonUp);

        jButtonStop.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/globe.gif")));
        jButtonStop.setBorder(null);
        jButtonStop.setBorderPainted(false);
        jButtonStop.setContentAreaFilled(false);
        jButtonStop.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/unvisible_arrow.png")));
        jButtonStop.setEnabled(false);
        jButtonStop.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStopActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonStop);

        jButtonHome.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/home.png")));
        jButtonHome.setBorder(null);
        jButtonHome.setBorderPainted(false);
        jButtonHome.setContentAreaFilled(false);
        jButtonHome.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/globeDisabled.gif")));
        jButtonHome.setEnabled(false);
        jButtonHome.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonHome.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonHomeActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonHome);

        jButtonJPackage.setIcon(new javax.swing.ImageIcon(getClass().getResource("/globaldocs/res/jpackage.png")));
        jButtonJPackage.setBorder(null);
        jButtonJPackage.setBorderPainted(false);
        jButtonJPackage.setContentAreaFilled(false);
        jButtonJPackage.setEnabled(false);
        jButtonJPackage.setPreferredSize(new java.awt.Dimension(20, 14));
        jButtonJPackage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonJPackageActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonJPackage);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    boolean jPackageRequest=false;
    
    private void jButtonJPackageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonJPackageActionPerformed
// TODO add your handling code here:
      TreePath tp=jTree.getSelectionPath();
      if (tp!=null) try {
        TheMutableTreeNode tn=(TheMutableTreeNode)tp.getLastPathComponent();
        URL home=tn.jPackageHome();
        if (home!=null) {
            jPackageRequest=true;
            navigate(home);
        }
      } catch (Throwable t) {}    
    }//GEN-LAST:event_jButtonJPackageActionPerformed

    private void jTreeMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTreeMousePressed
// TODO add your handling code here:
        if ((evt.getButton()==evt.BUTTON1)&&
                (jTree.getRowForLocation(evt.getX(), evt.getY()) != -1)) {
            TreePath
                    selPath = jTree.getPathForLocation(evt.getX(), evt.getY());
            if (selPath.equals(jTree.getSelectionPath())) {
                Object selected=selPath.getLastPathComponent();
                boolean noUrl=true;
                URL u=null;
                if (selected!=null && selected instanceof TheMutableTreeNode) {
                    TheMutableTreeNode n=(TheMutableTreeNode)selected;
                    try {
                        u=n.getUrl();
                        if (u!=null) {
                            if (u.equals(jHtmlEditorPane.getPage()))
                                noUrl=false;
                        }
                    } catch (Throwable t) {
                        System.err.println(t);
                    }
                }
                if (noUrl&&u!=null) {
                  navigate(u);
                  changeUpButtonState();
                }
            }
        }
    }//GEN-LAST:event_jTreeMousePressed

    private void jTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTreeValueChanged
// TODO add your handling code here:
        oldPath=evt.getOldLeadSelectionPath();
        
        if (evt.getNewLeadSelectionPath()==null) return;
        
        Object selected=evt.getPath().getLastPathComponent();
        boolean noUrl=true;
        if (selected!=null && selected instanceof TheMutableTreeNode) {
            TheMutableTreeNode n=(TheMutableTreeNode)selected;
            try {
                URL u=n.getUrl();
                if (u!=null) {
                  if (url2node(jHtmlEditorPane.getPage())!=n)
                    navigate(u);
                  noUrl=false;
                }  
                /*
                URL u=n.getUrl();
                if (u!=null) {
                    if (!u.equals(jHtmlEditorPane.getPage()))
                        jHtmlEditorPane.setPage(u);
                    noUrl=false;
                }
                 */
            } catch (Throwable t) {
                System.err.println(t);
            }
        }
        if (noUrl) {
            navigate(emptyUrl);
        }
        changeUpButtonState();
        
    }//GEN-LAST:event_jTreeValueChanged

    private void jButtonHomeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonHomeActionPerformed
// TODO add your handling code here:
      TreePath tp=jTree.getSelectionPath();
      if (tp!=null) {
        TheMutableTreeNode tn=(TheMutableTreeNode)tp.getLastPathComponent();
        URL home=tn.getHome();
        if (home!=null) navigate(home);
      }
    }//GEN-LAST:event_jButtonHomeActionPerformed

    private void jButtonStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStopActionPerformed
// TODO add your handling code here:
        if (prevUrl!=null) {
          navigate(prevUrl);
//          if (oldPath==null) jTree.clearSelection();
          jButtonStop.setEnabled(false);
        }
    }//GEN-LAST:event_jButtonStopActionPerformed

    private void jButtonUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpActionPerformed
// TODO add your handling code here:
        TheMutableTreeNode tn=null;
        TreePath tp=jTree.getSelectionPath(),tp1=null,tp2=null;
        if (tp!=null) {
            tn=(TheMutableTreeNode)tp.getLastPathComponent();
            if (tn!=null&&tn.getLevel()>1) {            
              jTree.collapsePath(tp);
              tp=tp.getParentPath();
              jTree.collapsePath(tp);
              if (ASSEMBLES.equals(tn.getUserObject())) {
                tp1=tp.getParentPath();
                if (tn.getLevel()>2) jTree.setSelectionPath(tp1);
                jTree.collapsePath(tp1);                  
              } else
              if (ASSEMBLES.equals(tn.getParentUserObject())) {
                tp1=tp.getParentPath();
                tp2=tp1.getParentPath();
                jTree.setSelectionPath(tp2);
                jTree.collapsePath(tp1);
                jTree.collapsePath(tp2);
              } else
                jTree.setSelectionPath(tp);
            }
        }
    }//GEN-LAST:event_jButtonUpActionPerformed

    private void jButtonNextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNextActionPerformed
// TODO add your handling code here:        
      history.forward();
    }//GEN-LAST:event_jButtonNextActionPerformed

    private void jButtonPrevActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPrevActionPerformed
// TODO add your handling code here:
      history.back();
    }//GEN-LAST:event_jButtonPrevActionPerformed

    JScrollBar  viewer_hs=null,viewer_vs=null;
    
    void navigate(URL u) {
      try {
        
        history.saveThePosition();
          
        jHtmlEditorPane.setPage(u);
      } catch (Throwable t) {
        System.err.println(t);
      }  
    }
    
    URL prevUrl=null;
    
    private void jHtmlEditorPanePropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jHtmlEditorPanePropertyChange

      if ("document".equals(evt.getPropertyName())&&(evt.getNewValue()!=null)) {
          Document olddoc=(Document)evt.getOldValue();
          URL u=(URL)olddoc.getProperty(Document.StreamDescriptionProperty);
          
      //    int pos=jHtmlEditorPane.viewToModel(new Point(0,0));
      //    System.out.println(pos);
          
          Document newdoc=(Document)evt.getNewValue();
          if (newdoc.getProperty(Document.StreamDescriptionProperty)!=null) {
                    
              prevUrl=u;
              jButtonStop.setEnabled(true);
          }    
          lastSearchEnd=0;
      }
      
      if ("page".equals(evt.getPropertyName())) {
          // the page load is completed
          URL u=(URL)evt.getNewValue();
          TheMutableTreeNode tn=url2node(u);
          
          if (tn==null) {
              jButtonHome.setEnabled(false);
              jButtonJPackage.setEnabled(false);
              Document doc=jHtmlEditorPane.getDocument();
              String title=(String)doc.getProperty("title");
              setTitle(TITLE_PREFIX+(title==null?"":title));
              history.add(u,title);
            //  jTree.clearSelection();
          } else {
              boolean homeIsEnabled=tn.hasHome(),
                      jpIsEnabled=tn.jPackageHome()!=null;
              jButtonHome.setEnabled(homeIsEnabled);
              if (homeIsEnabled) 
                jButtonHome.setToolTipText(tn.getVersionedName()+" -- none API help pages");
              jButtonJPackage.setEnabled(jpIsEnabled);
              if (jpIsEnabled)
                jButtonJPackage.setToolTipText(tn.getVersionedName()+" -- JPackage info");
              
              setTitle(TITLE_PREFIX+tn.getTitle());
              history.add(u,tn.getTitle());
              
              TheMutableTreeNode sel=
                 (TheMutableTreeNode) jTree.getSelectionPath().getLastPathComponent();
              
              if (tn!=sel) {
                TreePath tp=new TreePath(tn.getPath());
                jTree.setSelectionPath(tp);
                jTree.scrollPathToVisible(tp);
              }
          }
          
          if (jPackageRequest) {
            jPackageRequest=false;
            findThenMove("RPM Information for");
          }
          
          jButtonStop.setEnabled(false);
          
          //System.out.println(evt.getNewValue()+" "+evt.getOldValue());
      }
    }//GEN-LAST:event_jHtmlEditorPanePropertyChange

    void configureLinkMenu(JMenu miLink,final URL u) {

            miLink.removeAll();
            JMenuItem mi=miLink.add(u.toString());
            mi.setEnabled(false);
            miLink.addSeparator();
            mi=miLink.add("Copy URL");
            mi.setMnemonic(KeyEvent.VK_R);
            
            mi.addActionListener(
              new ActionListener() {
                  public void actionPerformed(ActionEvent e) {
                    StringSelection ss=new StringSelection(u.toString());
                    clipboard.setContents(ss,ss);
                  }
              }
            );
            
            if (!externalBrowser.isEmpty()) {
         
              for (final String browser:externalBrowser.keySet()) {
                mi=miLink.add("open with "+browser);
                
                mi.addActionListener(
                  new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                       openUrlIn(browser,u.toString());
                    }
                  }
                );         
                
              }
            }
            
    }
    
    private void jHtmlEditorPaneHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {//GEN-FIRST:event_jHtmlEditorPaneHyperlinkUpdate

        if (evt.getEventType() == HyperlinkEvent.EventType.ENTERED) {
          //System.out.println(evt.getURL());
          synchronized(miLink.getTreeLock()) {
            configureLinkMenu(miLink,rewrite(evt.getURL()));            
            miLink.setVisible(true);
          }
        } else
        if (evt.getEventType() == HyperlinkEvent.EventType.EXITED) {
          miLink.setVisible(false);
        } else            
        if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
            JEditorPane pane = (JEditorPane) evt.getSource();
            if (evt instanceof HTMLFrameHyperlinkEvent) {
                HTMLFrameHyperlinkEvent  ev = (HTMLFrameHyperlinkEvent)evt;
                HTMLDocument doc = (HTMLDocument)pane.getDocument();
                doc.processHTMLFrameHyperlinkEvent(ev);
            } else {
                    /*
                  JScrollBar vs=jScrollBrowserPane.getVerticalScrollBar();
                  int vpos=vs.isVisible()?vs.getValue():0;
                  System.out.println(vpos);
                     */
                  navigate(rewrite(evt.getURL()));
            }
        }
        
    }//GEN-LAST:event_jHtmlEditorPaneHyperlinkUpdate
    
    Clipboard clipboard = getToolkit().getSystemClipboard();

    
 //   final String J2SE1_4_PREFIX="http://java\\.sun\\.com/j2se/1\\.4(\\.\\d){0,1}/";
    static final String J2SE1_5_PREFIX="http://java.sun.com/j2se/1.5.0/";
    
    static final Pattern J2SE14=Pattern.compile("/j2se/1\\.(2|3|4)(\\.\\d){0,1}/");
    static final Pattern J2SE14API=Pattern.compile("/j2se/1\\.(2|3|4)(\\.\\d){0,1}/api/");
    static final String  JAVA_LOC_REL="file:/usr/share/javadoc/java/";
    
    URL rewrite(URL u) {
      String s=u.toString();
      try {
          if (s.startsWith(JAVA_LOC_REL))
             return
               new URL(J2SE1_5_PREFIX+"docs/api/"+s.substring(JAVA_LOC_REL.length()));
          Matcher m=J2SE14API.matcher(s);
          if (m.find()) {
             s=J2SE1_5_PREFIX+"docs/api/"+s.substring(m.end());
             u=new URL(s);
          } else {
              m=J2SE14.matcher(s);
              if (m.find()) {
                  s=J2SE1_5_PREFIX+s.substring(m.end());
                  u=new URL(s);
              }
          }
          // s=s.replaceFirst(J2SE1_4_PREFIX,J2SE1_5_PREFIX);
      } catch (Throwable t) {}
      return u;
    }
    
    
    URL emptyUrl=getResourceUrl("globaldocs/res/empty.html");
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        System.setProperty("swing.aatext", "true");
        final JFrame f=new MainFrame();
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                f.setVisible(true);
            }
        });
        
    }
    
    class History  {
        Point requestedPos=null;
        class Item {
            URL url;
            String title;
            Point pos=new Point(0,0);
            Item(URL u,String t) {
                url=u; title=t;
            }
            public void navigate() {
               MainFrame.this.navigate(url);
            }
            public void saveThePosition() {                
              pos.x=viewer_hs.isVisible()?viewer_hs.getValue():0;
              pos.y=viewer_vs.isVisible()?viewer_vs.getValue():0;
            }
        };
        
        private int position=0,toSkip=0;
        
        private Vector<Item> history=new Vector<Item>();
        
        public void back() {
          synchronized(history) {  
            if (position>1) {
                saveThePosition();
                Item it=history.elementAt(--position-1);
                requestedPos=(Point)it.pos.clone();
                it.navigate();
                ++toSkip;
            }
          } 
        }
        
        public void forward() {
          synchronized(history) {
            if (position<history.size()) {
                saveThePosition();
                Item it=history.elementAt(position++);
                requestedPos=(Point)it.pos.clone();
                it.navigate();
                ++toSkip;
            }
          }  
        }
        
        public void saveThePosition() {
          synchronized(history) {  
            if (!history.isEmpty())
              history.elementAt(position-1).saveThePosition();
          }
        }
        
        public synchronized void add(URL url,String title) {
            if (toSkip>0) --toSkip;
            else synchronized(history) {
                if (history.size()>position&&url.equals(history.elementAt(position).url)) {
                  ++position;
                } else {
                  if (history.size()>position) history.setSize(position);
                  if (position>0&&emptyUrl.equals(history.lastElement().url)) {
                    --position; history.setSize(position);
                  } 
                  history.add(new Item(url,title)); ++position;
                }
            }    
                if (requestedPos!=null) {
                  viewer_hs.setValue(requestedPos.x);
                  viewer_vs.setValue(requestedPos.y);
                  requestedPos=null;
                }
            changeButtonState();
            synchronized(miPage.getTreeLock()) {
              configureLinkMenu(miPage,rewrite(url));            
            }        
        }
        
        private void changeButtonState() {
            synchronized(history) {
                jButtonNext.setEnabled(
                        position<history.size()&&
                        !emptyUrl.equals(history.elementAt(position).url)
                        );
                jButtonPrev.setEnabled(position>1);
                synchronized(miNavigate.getTreeLock()) {
                    miNavigate.removeAll();
                    
                    Set<URL> urlset=new HashSet<URL>();
                    for (int ix=history.size();ix>0;ix--) {
                        final Item it=history.elementAt(ix-1);
                        final int ixx=ix;
                        URL wr=withoutRef(it.url);
                        if (it.url.equals(emptyUrl)||urlset.contains(wr)) 
                          continue;
                        urlset.add(wr);
                        JMenuItem mi=miNavigate.add(it.title);
                        mi.setIcon((ixx==position)?icRightArrow:icNull);
                        mi.addActionListener(
                                new ActionListener() {
                            public synchronized void actionPerformed(ActionEvent e) {
                                saveThePosition();
                                position=ixx;
                                requestedPos=(Point)it.pos.clone();
                                it.navigate();
                                ++toSkip;
                            }
                        }
                        );
                    }
                }
            }
        }
    };
    
    History history=new History();
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonHome;
    private javax.swing.JButton jButtonJPackage;
    private javax.swing.JButton jButtonNext;
    private javax.swing.JButton jButtonPrev;
    private javax.swing.JButton jButtonStop;
    private javax.swing.JButton jButtonUp;
    private javax.swing.JEditorPane jHtmlEditorPane;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollBrowserPane;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTree jTree;
    // End of variables declaration//GEN-END:variables
    
}
